<?php
/*!! Structure.Actions.Photoalbum:
  {{PhotoAlbum

  Version 2.0
  Janvarev V. and Pavlov M.

  Show photogallery
  Correct work with crosssite feature.

  [perrow=<Number of images in rows> (default = 3)]
  [smallid=<Difference between big and small images>]
  [nodesc=1 - hide descriptions]
  [title="Photoalbum"]
  [toblank="1|new"] - show large images without page (if = "new" in new browser window)
  [notitle="1"] - hide fieldset external border
  }}

@link Structure.Actions, User.EndUser:
!!  .!!
*/

  // Loading parameters

  if(!$smallid) $smallid="tn_";
  if(!$title) $title="Photoalbum";
  if(!$perrow) $imagesrow = 3; else $imagesrow = $perrow;
  if(!$height) $height = 150;

  $filepage = $this->page;

  // Loading files

  $files = $this->LoadAll( "select id, page_id, filesize, picture_w, picture_h, filename, description, uploaded_dt, user from ".
                              $this->config["table_prefix"]."upload where ".
                             " page_id = '". ($filepage["id"])."' order by id asc");
  if (!is_array($files)) $files = array();

  // Making an album

  $cur=0;
  if($notitle!="1") echo "<fieldset><legend><b>".htmlspecialchars($title)."</b></legend>";

  if(!$_GET["photo"]) {

    // There is a root of photoalbum

  ?>
    <div class="photoalbum">
    <table align="center" width="100%">

    <?php
    //echo $this->GetConfigValue("root_url").$this->NpjTranslit($this->Getpagetag());//ereg_replace("","",$filename).'<br>';
    foreach( $files as $file )
    {
      $filename = $file["filename"];
      if(strstr($filename,$smallid)) {
        if($cur==0) echo("<tr>");
        echo("<td align=\"center\">");


              $path2 = "file:";
              $link = $this->Link($path2.$filename, "", $file["description"]);
              //echo $filename.'<br>';
              //echo ereg_replace($smallid,"",$filename).'<br>';

              $linkto=ereg_replace($smallid,"",$filename);
              if(!$toblank)
                   echo("<a href=\"".$this->Href("", $this->tag,"photo=".$linkto)."\">".$link."</a>");
              else
                  if ($toblank=="new")
                     echo("<a href=\"".$this->Href("files", $this->tag,"get=".$linkto)."\" target=\"_blank\">".$link."</a>");
                  else
                     echo("<a href=\"".$this->Href("files", $this->tag,"get=".$linkto)."\">".$link."</a>");
              if(!$nodesc) echo("<br><br><b>".$file["description"]."</b><br><br>");
              echo("</td>\n");
              $cur=($cur+1)%$imagesrow;
              if($cur==0) echo("</tr>");
      } elseif(strstr(strtolower($filename),'.jpg')) {

       if (!file_exists($this->config["upload_path_per_page"].'/@page'.$this->page["id"].'@'.$smallid.$filename)){
        //if($_REQUEST["op"]=="regen") {
          @set_time_limit(0);
          @ignore_user_abort(true);
        $srcImage = ImageCreateFromJPEG($this->config["upload_path_per_page"].'/@page'.$this->page["id"].'@'.$filename);
        $newfilename =  $this->config["upload_path_per_page"].'/@page'.$this->page["id"].'@'.$smallid.$filename;
        $srcWidth = ImageSX( $srcImage );
        $srcHeight = ImageSY( $srcImage );
        $diw = (int)(($srcWidth / $srcHeight) * $height);
        $destImage = imagecreatetruecolor( $diw, $height);

        $kX = $srcWidth/$diw;
        $kY = $srcHeight/$height;

        $gd_version = 2;
        $resize_function = ($gd_version == 1) ? 'imagecopyresized' : 'imagecopyresampled';

        @$resize_function($destImage, $srcImage, 0, 0, 0, 0, $diw, $height, $srcWidth, $srcHeight);
        ImageJPEG( $destImage, $newfilename);
        ImageDestroy( $srcImage );
        ImageDestroy( $destImage );
          $this->Query("INSERT INTO `".$this->config["table_prefix"]."upload` (`page_id`, `filename`, `description`, `uploaded_dt`, `filesize`, `picture_w`, `picture_h`, `file_ext`, `user`) VALUES ('".quote($filepage["id"])."',
          '".quote($smallid.$filename)."', '".quote($file["description"])."', '".date("Y-m-d H:i:s")."', ".sizeof($newfilename).", '".quote($diw)."', '".quote($height)."', 'jpg', '".quote($file["user"])."')");
        //}
        if($cur==0) echo("<tr>");
        echo("<td align=\"center\">");


              $path2 = "file:";
              $link = $this->Link($path2.$smallid.$filename, "", $file["description"]);
              //echo $filename.'<br>';
              //echo ereg_replace($smallid,"",$filename).'<br>';

              $linkto=ereg_replace($smallid,"",$filename);
              if(!$toblank)
                   echo("<a href=\"".$this->Href("", $this->tag,"photo=".$linkto)."\">".$link."</a>");
              else
                  if ($toblank=="new")
                     echo("<a href=\"".$this->Href("files", $this->tag,"get=".$linkto)."\" target=\"_blank\">".$link."</a>");
                  else
                     echo("<a href=\"".$this->Href("files", $this->tag,"get=".$linkto)."\">".$link."</a>");
              if(!$nodesc) echo("<br><br><b>".$file["description"]."</b><br><br>");
              echo("</td>\n");
              $cur=($cur+1)%$imagesrow;
              if($cur==0) echo("</tr>");

      }
      }
    }
          ?>

  </table>
  </div>
  <?php  } else {

   // We choose one photo

    ?>
    <div align="center">
    <?php
              $path2 = "file:";
              $link = $this->Link($path2.$_GET["photo"], "", $_GET["photo"]);

              echo($link);
              echo("<br /><br />");
              echo("<a href=\"".$this->Href("",$this->tag,"")."\">&lt; </a>");
    ?>
    </div>
  <?php
  }
  if($notitle!="1") echo  "</fieldset>";
  if($this->IsAdmin()) {
    echo '<br /><div align="center"><a href="'.$this->href('upload').'" target="_blank">   </a></div>';
  }
?>
